Subject: Re: Win32s/mingw32: please stop this nonsense!
From: [email-masked] (root)

28 Apr 1998 23:17:55 -0700
Sender: [email-masked]
Message-ID: <[email-masked]>
References: <[email-masked]>
To: [email-masked]
Cc: [email-masked]
Content-Type: text

> >
> >win32s is still a 16-bit executable system, and the code for generating
> >loads and stores is different than under MINGW32 or CYGWIN32.  I'd be
> >surprised if you could get any kind of a gcc program to load under
> >win32s.
> >>
This is completely crazy.
I mean really crazy.
For starters:
>>>> Win32s uses the same executable format as windows 95/NT!!!!!!!!!

The only requirement is that all executables should have the .reloc section.
THAT IS ALL THE DIFFERENCE!!!
(What the executable format goes of course).

> 
> Win32s is just an extension of Windows 3.1 
YES
> and uses the same executable format, 
NO NO AND NO!!!

> which is an extension of the Dos executable format and uses
> 16-bit registers to form a 32-bit address, something that will cause an
> immediate exception if it appears within a `flat-model' program for
> Windows 95/NT.

You are daydreaming, and speaking NONSENSE!!!!!
I have compiled programs with lcc-win32, i.e. flat model 32 bit programs,
and they will run under Win32s!!!

> 
> Windows 95/NT programs use a set of registers that was added to the Intel
> CPU architecture after the Windows 3.0 and 3.1 series was designed. These
> registers are not used for Windows 3.0 and 3.1 programs.  Hence, the
> incompatibility.

This is totally absurd. Since Intel introduced the 386 (before windows 3.0
came out) there hasn't been any new registers added to the intel architecture:
We have EAX EBX ECX EDX ESI ESP since the 386 in 32 bits. Windows 3.0 used
only the 16 bit parts of those registers.

Win32s uses always the 32 bit registers!!!

> 
> To get Windows 3.1 executables from gcc, you have to change code-
> generation templates to generate the earlier non-flat-model code.
This is true, but as I told before Win32s is NOT windows 3.1!!!!!!
No modifications are needed to gcc or any other 32 bit compiler to run
under win32s.

But if you do not want to support win32s because is obsolete and it is too
much work, then SAY IT SO, as I do: lcc-win32 does NOT support win32s, but
users MAY compile programs to run under win32s if they add the -reloc
option to the linker.

-- 
Jacob Navia	Logiciels/Informatique
41 rue Maurice Ravel			Tel 01 48.23.51.44
93430 Villetaneuse 			Fax 01 48.23.95.39
France
-
For help on using this list (especially unsubscribing), send a message to
"[email-masked]" with one line of text: "help".